﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;
using Infragistics.Win.UltraWinTree;

namespace WinGridMultipleBands
{
    public partial class Form1 : Form
    {
        private DataSet Generate()
        {
            DataTable[] tables = new DataTable[4];

            for (int i = 0; i < 4; i++)
            {
                tables[i] = new DataTable();
                tables[i].Columns.Add("ID", typeof(int)).AutoIncrement = true;
                tables[i].Columns.Add("FID", typeof(int));
                tables[i].Columns.Add("Null", typeof(string));
                for (int col = 0; col < 3; col++)
                    tables[i].Columns.Add("Col" + col.ToString(), typeof(string)).DefaultValue = "Text table" + i.ToString();

            }

            for (int i1 = 0; i1 < 5; i1++)
            {
                tables[0].Rows.Add(null,i1);
                int key0 = (int)tables[0].Rows[i1].ItemArray[0];
                
                for (int i2 = 0; i2 < 5; i2++)
                {
                    tables[1].Rows.Add(null, key0);
                    int key1 = (int)tables[1].Rows[tables[1].Rows.Count -1].ItemArray[0];
                    for (int i3 = 0; i3 < 5; i3++)
                    {
                        tables[2].Rows.Add(null, key1);
                        int key2 = (int)tables[2].Rows[tables[2].Rows.Count - 1].ItemArray[0];
                        for (int i4 = 0; i4 < 5; i4++)
                        {
                            tables[3].Rows.Add(null, key2);
                        }
                    }
                }
            }

            DataSet ret = new DataSet();
            ret.Tables.AddRange(tables);


            for (int i = 3; i > 0; i--)
                ret.Relations.Add(ret.Tables[i - 1].Columns["ID"], ret.Tables[i].Columns["FID"]);
            //ret.Relations.Add(ret.Tables[3].Columns["ID"], ret.Tables[0].Columns["FID"]);
            return ret;
        }

        public Form1()
        {
            InitializeComponent();
            //ultraGrid1.DisplayLayout.MaxBandDepth = 5;
            //Infragistics.Win.AppStyling.StyleManager.Load("Test.isl");
            //ultraGrid1.DisplayLayout.Override.RowAlternateAppearance.BackColor = Color.Fuchsia;
            //ultraGrid1.DisplayLayout.Bands[0].Columns.Add("btn");
            //ultraGrid1.DisplayLayout.Bands[0].Columns["btn"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            //ultraGrid1.DisplayLayout.Bands[0].Columns["btn"].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;
            //ultraGrid1.DisplayLayout.Bands[0].Columns["btn"].CellButtonAppearance.BackColor = Color.Fuchsia;
            MyDAL dataclass = new MyDAL();
            ultraGrid1.DataSource = dataclass.Generate();
            ultraGrid1.DisplayLayout.Override.AllowRowFiltering = DefaultableBoolean.True;

            //ultraGrid1.Rows.ExpandAll(true);
            
            //ultraGrid1.DisplayLayout.Override.RowFilterMode = RowFilterMode.AllRowsInBand;
            //ultraGrid1.DisplayLayout.Bands[4].ColumnFilters["Null"].FilterConditions.Add(FilterComparisionOperator.NotEquals, null);
            //ultraGrid1.DisplayLayout.Bands[2].ColumnFilters["Null"].FilterConditions.Add(FilterComparisionOperator.NotEquals, null);
            //ultraGrid1.DisplayLayout.Override.FixedRowIndicator = FixedRowIndicator.Button;
           // ultraGrid1.DisplayLayout.Override.FixedRowAppearance.BackColor = Color.Red;
            //ultraGrid1.Rows[0].Fixed = true;
            //ultraGrid1.Rows[0].ChildBands[0].Rows[3].Fixed = true;
          // ultraGrid1.DisplayLayout.Bands[0].ColumnFilters["Null"].FilterConditions.Add(FilterComparisionOperator.NotEquals, null);

            ultraGrid1.DisplayLayout.Override.AllowColSizing = AllowColSizing.Synchronized;

            ultraGrid1.DisplayLayout.Bands[1].Indentation = 0;
            ultraGrid1.DisplayLayout.Bands[0].Override.ButtonStyle = UIElementButtonStyle.Default;


          
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            //if (e.Row.IsAlternate && e.Row.Cells["btn"].EditorResolved != null)
            //{
            //    e.Row.Cells["btn"].ButtonAppearance.BackColor = Color.Red;//ultraGrid1.DisplayLayout.Override.RowAlternateAppearance.BackColor;
            //}
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            for (int index = 0; index < e.Layout.Bands.Count; index++)
            {
                UltraGridBand band = e.Layout.Bands[index];
                UltraTreeNode node = ultraTree1.Nodes.Add(band.Index.ToString(), band.Key);
                foreach (UltraGridColumn col in band.Columns)
                    node.Nodes.Add(string.Format("{0}{1}",band.Index, col.Key));
            }
            ultraTree1.ExpandAll();
           
        }
    }
}
